/***********************************(SSD1331.c)**********
 *	SPIL@ELJ[OtBbNCu(SSD1331)
 ********************************************************/

#include "mcc_generated_files/mcc.h"
#include "myProject.h"
#include "Font_5x7.h"

#define  COLOR256	0x20
#define  COLOR64K2	0x42
#define  COLOR64K3  0x82

#define OLED_BF_SIZE    80

#define ROM_MAP2

//---  tHgf[^AhX)
#define F_H_ASC     0x00200     // pASCII(20-7E) **
#define F_H_KANA    0x00800     // pJi(A1-DF)
#define F_SYM1      0x01000     // L1(2121-217E)
#define F_SYM2      0x01BC0     // L2(2221-222E)
#define F_SYM3      0x01D80     // L3(223A-2241)
#define F_SYM4      0x01E80     // L4(224A-2250)
#define F_SYM5      0x01F60     // L5(225C-226A)
#define F_SYM6      0x02140     // L6(2272-2279)
#define F_SYM7      0x02240     // L7(227E)
#define F_NUM       0x02260     // (2330-2339)
#define F_ASC       0x023A0     // ASCiimn(2341-235A)
#define F_ASC2      0x026E0     // ASCiimn(2361-237A)
#define F_HIRA      0x02A20     // Ђ炩(2421-2473)
#define F_KATA      0x03480     // J^Ji(2521-2576)
#define F_PCDEF     0x06800     // @ˑi2Dxx) **
#define F_GRK1      0x1B2A0     // MVmn(2621-2638)
#define F_GRK2      0x1B5A0     // MVmn(2641-2668)
#define F_CRL1      0x1B8A0     // Lmn(2721-2741)
#define F_CRL2      0x1BCC0     // Lmn(2751-2771)
#define F_RULE      0x1C0E0     // r (2821-2840)
#define F_KAN1      0x04000     // P(3021-4F53)
#define F_KAN0      0x08000     // PiVAhXj**
#define F_KAN2      0x20000     // Q(5021-7426) **
#define F_SYM_A     0x3A800     // SL(2121-2D7C)

#define NO_FONT     0x010A0      // tHgꍇ

static uint8_t CrtLn = 0;       // ݍsiy[Wjʒu

static uint8_t gBf[OLED_BF_SIZE];      // OtBbN\p


//---  SSD1331 
void SSD1331_Init(){

  CS1_SetLow();                 // Reset OLED (SSD1331))
  __delay_ms(50);               // ŏIIOLCDZbg͏ȗ
  CS1_SetHigh();
    
  __delay_ms(500);  
  gCS_SetLow();					//  Select gCS
  gDC_SetLow();					//  Select Command

  SPI1_ExchangeByte(0xAE);		//  Set Display Off
  SPI1_ExchangeByte(0xA0);		//  Remap & Color Depth setting@
    SPI1_ExchangeByte(0x20);	// =20H [40],(0b00100000); 
    							//   A[7:6] = 00; 256 color
    							//   A[5] = 1; Enable COM Sprit
    							//   A[4] = 0; Scan from 0-COMn
    							//   A[3] = 0; Disable Swaping
    							//   A[2] = 0; Norma Order (RGB)
    							//   A[1] = 0; RAM Colum Seg:95-0
    							//   A[0] = 0; Horizontal Address Incriment
  SPI1_ExchangeByte(0xA1);		//  Set Display Start Line
    SPI1_ExchangeByte(0);		// = 0 [00]
  SPI1_ExchangeByte(0xA2);		//  Set Display Offset
    SPI1_ExchangeByte(0);		// = 0 [00]
  SPI1_ExchangeByte(0xA4);		//  Set Display Mode (Normal)
  SPI1_ExchangeByte(0xA8);		//  Set Multiplex Ratio
    SPI1_ExchangeByte(63);		// = 63 [63]
  SPI1_ExchangeByte(0xAD);		//  Set Master Configration
    SPI1_ExchangeByte(0x8E);	// =8E [8F],a[0]=0 Select external Vcc supply
  SPI1_ExchangeByte(0xB0);		//  Power Save Mode
    SPI1_ExchangeByte(0x1A);	// = 1AH [1A},Enable power save mode
  SPI1_ExchangeByte(0xB1);		//  Phase 1 and 2 period adjustment
    SPI1_ExchangeByte(0x74);	// = 74H [74]
  SPI1_ExchangeByte(0xB3);		//  Display Clock DIV
    SPI1_ExchangeByte(0xF0);	// = F0H [D0]
  SPI1_ExchangeByte(0x8A);		//  Pre Charge A
    SPI1_ExchangeByte(0x81);	// = 81H [81]
  SPI1_ExchangeByte(0x8B);		//  Pre Charge B
    SPI1_ExchangeByte(0x82);	// = 82H [82]
  SPI1_ExchangeByte(0x8C);		//  Pre Charge C
    SPI1_ExchangeByte(0x83);	// = 83H [83]
  SPI1_ExchangeByte(0xBB);		//  Set Pre-charge level
    SPI1_ExchangeByte(0x3A);	// = 3AH [3E]
  SPI1_ExchangeByte(0xBE);		//  Set VcomH
    SPI1_ExchangeByte(0x3E);	// = 3EH [3E]
  SPI1_ExchangeByte(0x87);		//  Set Master Current Control
    SPI1_ExchangeByte(0x06);	// = 06H [0F]
  SPI1_ExchangeByte(0x15);		//  Set Column Address
    SPI1_ExchangeByte(0);		// = 00 [00]
    SPI1_ExchangeByte(95);		// = 95 [95]
  SPI1_ExchangeByte(0x75);		//  Set Row Address
    SPI1_ExchangeByte(0);		// = 00 [00]
    SPI1_ExchangeByte(63);		// = 63 [63]
  SPI1_ExchangeByte(0x81);		//  Set Contrast for Color A
    SPI1_ExchangeByte(255);		// = 255 [80]
  SPI1_ExchangeByte(0x82);		//  Set Contrast for Color B
    SPI1_ExchangeByte(255);		// = 255 [80]
  SPI1_ExchangeByte(0x83);		//  Set Contrast for Color C
    SPI1_ExchangeByte(255);		// = 255 [80]
  SPI1_ExchangeByte(0xAF);		//  Set Display On
  __delay_ms(110); 				//  0xAFR}hŒ100msKv
  gCS_SetHigh();				//  DeSelect gCS
}

//---  SPI R}ho 
void gOLED_Cmd(uint8_t b){  
  gCS_SetLow();					// Select gCS
  gDC_SetLow();					// Select Command
  SPI1_ExchangeByte(b);			// SPI.write(b)
  gCS_SetHigh();				// DeSelect gCS
}

//---  SPI f[^o
void gOLED_Data(uint8_t b){  
  gCS_SetLow();					// Select gCS
  gDC_SetHigh();				// Select Data
  SPI1_ExchangeByte(b);			// SPI.write(b)
  gCS_SetHigh();				// DeSelect gCS
}

//----  RGB1oCg256F   ( R = 0-7, G = 0-7, B = 0-3 )
uint8_t RGB256(uint8_t r,uint8_t g, uint8_t b){
  return (uint8_t)((r << 5) | (g << 2) | b);
}

//----  RGB2oCg64kF   ( R = 0-31, G = 0-63, B = 0-31 )
uint16_t RGB64k(uint8_t r,uint8_t g, uint8_t b){
  return (uint16_t)((r << 11) | (g << 5) | b);
}

//---  F[hw(AhXwtj
void setMode(uint8_t md, uint8_t dir){
  dir &= 1;
  gCS_SetLow();					// Select gCs
  gDC_SetLow();					// Select Comand
  SPI1_ExchangeByte(0xA0);
    SPI1_ExchangeByte(md + dir);
  gCS_SetHigh();				// DeSelect gCS
}

//----- \GA̐ݒ
void setArea(uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1){
  gCS_SetLow();					// Select gCs
  gDC_SetLow();					// Select Comand
  SPI1_ExchangeByte(0x15);
    SPI1_ExchangeByte(x0);
    SPI1_ExchangeByte(x1);
  SPI1_ExchangeByte(0x75);
    SPI1_ExchangeByte(y0);
    SPI1_ExchangeByte(y1);
  gCS_SetHigh();				// DeSelect gCS
}

//----- \GÃZbg
void rstArea(){
  setArea(0,0,95,63);
}

//---  ʃNA
void gOLED_Clr(uint8_t x0,uint8_t y0,uint8_t x1,uint8_t y1){
  gCS_SetLow();                 // Select gCS
  gDC_SetLow();                 // Select Comand
  SPI1_ExchangeByte(0x25);      // Line Command
  SPI1_ExchangeByte(x0);        // Start X
  SPI1_ExchangeByte(y0);        // Start Y
  SPI1_ExchangeByte(x1);        // End X
  SPI1_ExchangeByte(y1);        // End Y
  gCS_SetHigh();                // DeSelect gCS
  __delay_ms(1);
}

//---  `
void gOLED_Line(uint8_t x0,uint8_t y0, uint8_t x1,uint8_t y1, uint8_t r, uint8_t g ,uint8_t b){
  gCS_SetLow();					// Select gCs
  gDC_SetLow();					// Select Comand
  SPI1_ExchangeByte(0x21);		// Line Command
  SPI1_ExchangeByte(x0);		// Start X
  SPI1_ExchangeByte(y0);		// Start Y    
  SPI1_ExchangeByte(x1);		// End X
  SPI1_ExchangeByte(y1);		// End Y
  SPI1_ExchangeByte(r);			// Line color Red
  SPI1_ExchangeByte(g);			// Line color Green
  SPI1_ExchangeByte(b);			// Line color Blue
  gCS_SetHigh();				// DeSelect gCs
  __delay_ms(1);
}

//--- lp``
void gOLED_Rect(uint8_t x0,uint8_t y0, uint8_t x1,uint8_t y1, uint8_t r, uint8_t g ,uint8_t b){
  gCS_SetLow();					// Select gCs
  gDC_SetLow();					// Select Comand
  SPI1_ExchangeByte(0x22);		// Rect Command
  SPI1_ExchangeByte(x0);		// Start X
  SPI1_ExchangeByte(y0);		// Star Y
  SPI1_ExchangeByte(x1);		// End X
  SPI1_ExchangeByte(y1);		// End Y
  SPI1_ExchangeByte(r);			// Line color Red
  SPI1_ExchangeByte(g);			// Line color Green
  SPI1_ExchangeByte(b);			// Line color Blue
  SPI1_ExchangeByte(r);			// Fill color Red
  SPI1_ExchangeByte(g);			// Fill color Green
  SPI1_ExchangeByte(b);			// Fill color Blue
  gCS_SetHigh();				// DeSelect gCS
  __delay_ms(1);
}

//---  摜Rs[
void gOLED_Copy(uint8_t x0,uint8_t y0, uint8_t x1,uint8_t y1, uint8_t dx, uint8_t dy){
  gCS_SetLow();					// Select gCs
  gDC_SetLow();					// Select Comand
  SPI1_ExchangeByte(0x23);		// Line Command
  SPI1_ExchangeByte(x0);		// Start X
  SPI1_ExchangeByte(y0);		// Start Y    
  SPI1_ExchangeByte(x1);		// End X
  SPI1_ExchangeByte(y1);		// End Y
  SPI1_ExchangeByte(dx);		// New Start X
  SPI1_ExchangeByte(dy);		// New Start Y
  gCS_SetHigh();				// DeSelect gCs
  __delay_ms(1);
}

//---  hԂOn/Off
void gOLED_Fill(uint8_t fl){
  gCS_SetLow();					// Select gCs
  gDC_SetLow();					// Select Comand
  SPI1_ExchangeByte(0x26);		// Fill Command
  SPI1_ExchangeByte(fl);		// Start X
  gCS_SetHigh();				// DeSelect gCs
  __delay_ms(1);
}

/******* Ep^[` ******/
//---  1hbg`i256Fj
void gOLED_Pset256(uint8_t x, uint8_t y,uint8_t col){
	setArea(x,y,x,y);
	gOLED_Data(col);
	rstArea();
}

//----- 1oCg8hbg`(256Fj
void Pset8(uint8_t b, uint8_t c){
  uint8_t i;
  uint8_t m = 1;
  for (i=0; i<8;i++){
    if(b & m) gOLED_Data(c);
    else      gOLED_Data(0);
    m <<= 1;
  }
}

//----  5x7hbgASCIIP\(256Fj
uint8_t gOLED_chrX(uint8_t x, uint8_t y, char dat, uint8_t c){
  char i,ptn;
  dat -= 0x20;						// AhXvZ
  setMode(COLOR256,1);				// AhXc
  setArea(x,y,x+4,y+7);				// `GAw
  for(i=0; i<5; i++) {
    ptn = Font[dat][i];
    if(ptn == 0xFF) break;			//Ȃ甲
    Pset8(ptn,c);					// 8hbg`
  }
  gOLED_Clr(x+i,y,x+i,y+7);			// P󂯂
  setMode(COLOR256,1);				// AhX
  rstArea();						// GAwNA
  return x+i+1;
}

//----  5x7hbgASCII\(256Fj 
uint8_t gOLED_strX(uint8_t x, uint8_t y, char *str, uint8_t c){
  uint8_t posX;
  posX = x;
  while(*str){
    posX = gOLED_chrX(posX, y, *str++, c);
  }
  return posX;
}

/******  \  ********/
//----  ptHgAhX擾
uint32_t HfntAdr(uint8_t chCode){
  #ifdef ROM_MAP2
        return (chCode - 0x20) * 16 + F_H_ASC; 
  #else
    if((chCode >= 0x20) & (chCode < 0x7F)){
        return (chCode - 0x20) * 16 + F_H_ASC;
    }else if((chCode > 0xA0) & (chCode <= 0xDF)){
        return  (chCode - 0xA0) * 16 + F_H_KANA;        
    }
  #endif
    return 0;
}

//----  8x16hbgP\(256Fj
uint8_t gOLED_HptnX(uint8_t x, uint8_t y, char *hp, uint8_t col){
  char i, ptn;
  setMode(COLOR256,1);				// AhXc
  setArea(x,y,x+7,y+7);             // `GAw
  for(i=0; i<8; i++) {
    ptn = *hp++;
    Pset8(ptn,col);					// 8hbg`
  }
  setArea(x,y+8,x+7,y+15);			// `GAw
  for(i=0; i<8; i++) {
    ptn = *hp++;
    Pset8(ptn,col);					// 8hbg`
  }
//  gOLED_Clr(x+i,y,x+i,y+15);		// P󂯂
  setMode(COLOR256,1);				// AhX
  rstArea();						// GAwNA
  return x+i;
}

//---- p(8x16)\ixposʒuԂj-----
uint8_t gOLED_HchrX(uint8_t xpos, uint8_t ypos, uint8_t chCode,uint8_t col){
    uint32_t adr;
    char  ptn[16];
    adr = HfntAdr(chCode);
    if(adr > 0){
        SPI_Mem_NRead(adr,(uint8_t *)ptn,16);
        xpos = gOLED_HptnX(xpos,ypos,ptn,col);
    }
    return xpos;
}

//-------- p\ixposʒuԂj-----
uint8_t gOLED_HstrX(uint8_t xpos, uint8_t ypos, char *str,uint8_t col){
    while(*str)  xpos = gOLED_HchrX(xpos, ypos, *str++,col);
    return xpos;                                //\ʒuԂ
}

//---- VtgJIS[JISϊ
uint16_t SJis2Jis(uint16_t sCd){
    uint8_t hi,lo;
    hi = sCd >> 8;
    lo = (uint8_t)sCd;
    if(hi <= 0x9F){
        if(lo < 0x9F)   hi = hi * 2 - 0xE1;
        else            hi = hi * 2 - 0xE0;
    }else{
        if(lo < 0x9F)   hi = (hi - 0xB0) * 2 - 1;
        else            hi = (hi - 0xB0) * 2;
    }
    if(lo < 0x7F)       lo = lo - 0x1F;
    else{
        if(lo < 0x9F)   lo = lo - 0x20;
        else            lo = lo - 0x7E;
    }
    return (uint16_t)(hi * 256 + lo);
}

//--- Sp(jtHgAhX擾)
uint32_t KfntAdr(uint16_t kCode){
    uint8_t msb, lsb;
    uint32_t lmsb, llsb;
    msb = kCode >> 8;
    lsb = (uint8_t)kCode & 0x000FF;
    lmsb = (uint32_t)msb;
    llsb = (uint32_t)lsb;
  #ifdef ROM_MAP2
    if(msb>=0x21 & msb<=0x28){                      // SpLEpEȕ
        if(lsb>=0x21 & lsb<=0x7E) return F_SYM1 + (lmsb-0x21)*3008+(llsb-0x21)*32;
        else                      return NO_FONT;
    }else if(msb==0x2d){                            // @ˑ
        if(lsb>=0x21 & lsb<=0x7E) return F_PCDEF + (lmsb-0x2d)*3008+(llsb-0x21)*32;
        else                      return NO_FONT;
  
  #else
    if(msb>=0x21 & msb<0x30){
        if(msb==0x21){                              // L1
            if(lsb>=0x21 & lsb<=0x7E) return F_SYM1+(lsb-0x21)*32;
            else                        return NO_FONT;
        }else if(msb==0x22){                        // L2
            if(lsb>=0x21 & lsb<=0x2E) return F_SYM2 + (lsb-0x21)*32;
            else                      return NO_FONT;
        }else if(msb==0x23){                        // ASCII
            if(lsb>=0x30 & lsb<=0x39) return F_NUM + (lsb-0x30)*32;
            if(lsb>=0x41 & lsb<=0x5A) return F_ASC + (lsb-0x41)*32;
            if(lsb>=0x61 & lsb<=0x7A) return F_ASC2 + (lsb-0x61)*32;
            else                      return NO_FONT;;
        }else if(msb==0x24){                        // Ђ炩
            if(lsb>=0x21 & lsb<=0x73) return F_HIRA + (lsb-0x21)*32;
            else                      return NO_FONT;
        }else if(msb==0x25){                        // J^Ji
            if(lsb>=0x21 & lsb<=0x76) return F_KATA + (lsb-0x21)*32;
            else                      return NO_FONT;
        }else if(msb==0x26){                        // MV
            if(lsb>=0x21 & lsb<=0x38) return F_GRK1 + (lsb-0x21)*32;
            if(lsb>=0x41 & lsb<=0x58) return F_GRK2 + (lsb-0x41)*32;
            else                      return NO_FONT;;
        }else if(msb==0x27){                        // L
            if(lsb>=0x21 & lsb<=0x41) return F_CRL1 + (lsb-0x21)*32;
            if(lsb>=0x51 & lsb<=0x71) return F_CRL2 + (lsb-0x51)*32;
            else                      return NO_FONT;;
        }else if(msb==0x28){                        // r
            if(lsb>=0x21 & lsb<=0x40) return F_RULE + (lsb-0x21)*32;
            else                      return NO_FONT;
        }

  #endif
    }else if(msb<0x50){                             // iPj
        if(lsb>=0x21 & lsb<=0x7E) return F_KAN0 + (lmsb-0x30)*3008+(llsb-0x21)*32;
        else                      return NO_FONT;
    }else if(msb<0x75){                             // iQj
        if(lsb>=0x21 & lsb<=0x7E) return F_KAN2 + (lmsb-0x50)*3008+(llsb-0x21)*32;
        else                      return NO_FONT;
    }
	return NO_FONT;
}
/*
//----- 1[h16hbg`(256Fj
void Pset16(uint16_t w, uint8_t c){
  Pset8(w >> 8,c);
  Pset8(w & 0xFF,c);
}*/

//----  16x16hbgP\(256Fj
uint8_t gOLED_KptnX(uint8_t x, uint8_t y, char *kp, uint8_t col){
  char i, ptn;
  setMode(COLOR256,1);				// AhXc
  setArea(x,y,x+15,y+7);			// `GAw
  for(i=0; i<16; i++) {
    ptn = *kp++;
    Pset8(ptn,col);					// 8hbg`
  }
  setArea(x,y+8,x+15,y+15);			// `GAw
  for(i=0; i<16; i++) {
    ptn = *kp++;
    Pset8(ptn,col);					// 8hbg`
  }
//  gOLED_Clr(x+i,y,x+i,y+15);		// P󂯂
  setMode(COLOR256,1);				// AhX
  rstArea();						// GAwNA
  return x+i;
}

//---- Sp(j\
uint8_t gOLED_ZchrX(uint8_t xpos, uint8_t ypos, uint16_t kCd,uint8_t col, uint8_t ed){
    uint32_t adr;
    uint16_t kk;
    uint8_t h,l;
    char ptn[32];

    if(ed & 0x01){
        h = (uint8_t)(kCd>>8);
        l = (uint8_t)kCd;
        kCd = l*256 + h;
    }
    if(ed < 2)  kk = SJis2Jis(kCd);
    else        kk = kCd;
//    sPrt_AdrDt(sBf,(uint32_t)kk, (uint8_t)kCd, '>'); puts(sBf);      
    adr = KfntAdr(kCd);
    SPI_Mem_NRead(adr,(uint8_t *)ptn,32);
 //    sPrt_AdrDt(sBf,adr, ptn[0], '>'); puts(sBf);  
    if(adr)	return gOLED_KptnX(xpos,ypos,ptn,col);
    return xpos;
}

//---- oCgPʈʒuőSp(j\
uint8_t gOLED_ZstrX(uint8_t xpos, uint8_t ypos, char *str,uint8_t col, uint8_t ed){
    uint16_t cd, *kjP;
    kjP = (uint16_t *)str;
    while(*kjP & 0xFF){
        xpos = gOLED_ZchrX(xpos,ypos,*kjP,col,ed);
        kjP++;
    }
    return xpos;
}

/****  OtBbNp^[\  ********/

//--- p^[f[^\(256Fj
void gOLED_ptnX(uint8_t x, uint8_t y, uint8_t *ptn, uint8_t xn, uint8_t yn, uint8_t vh){
  char i,j;
  if(vh)  setMode(COLOR256,1);		// AhXc
  else    setMode(COLOR256,0);		// AhX
  setArea(x,y,x+xn-1,y+yn-1);		// `GAw
  for(j=0; j<yn; j++) {
    for(i=0;i<xn;i++){
      gOLED_Data(*ptn++);
    }
  }
  rstArea();						// GAwNA
}

//--- p^[f[^\(64kFA[hPj
void gOLED_ptnX_FC2(uint8_t x, uint8_t y, uint8_t *ptn, uint8_t xn, uint8_t yn, uint8_t vh){
  char i,j,r,g,b;
  if(vh)    setMode(COLOR64K2,1);	// AhXc
  else      setMode(COLOR64K2,0);	// AhX
  setArea(x,y,x+xn-1,y+yn-1);		// `GAw
  for(j=0; j<yn; j++) {
    for(i=0;i<xn;i++){
      gOLED_Data(*ptn++);			// [15-11]:Red, [10-5]:Green, [4-0]:Blue
      gOLED_Data(*ptn++);			// rbOGfBAiʂoCgj
    }
  }
  rstArea();						// GAwNA
  setMode(COLOR256,0);				// 256F[h
}

//--- p^[f[^\(64kFA[hQj
void gOLED_ptnX_FC3(uint8_t x, uint8_t y, uint8_t *ptn, uint8_t xn, uint8_t yn, uint8_t vh){
  char i,j,d0,d1;
  if(vh)    setMode(COLOR64K3,1);	// AhXc
  else      setMode(COLOR64K3,0);	// AhX
  setArea(x,y,x+xn-1,y+yn-1);		// `GAw
  for(j=0; j<yn; j++) {
    for(i=0;i<xn;i++){
      gOLED_Data(*ptn++);			// Red   (0-63)
      gOLED_Data(*ptn++);			// Green (0-63)
      gOLED_Data(*ptn++);			// Blue  (0-63)
    }
  }
  rstArea();						// GAwNA
  setMode(COLOR256,0);				// 256F[h
}
/******* End of File ********/
