/***********************************(SSD1331.h)**********
 *	SPIL@ELJ[OtBbNwb_[t@C
 ********************************************************/

#define  COLOR256	0x20
#define  COLOR64K2	0x42
#define  COLOR64H3  0x82

//---  SSD1331 
void SSD1331_Init();

//---  SPI R}ho 
void gOLED_Cmd(uint8_t b);

//---  SPI f[^o
void gOLED_Data(uint8_t b);

//----  RGB1oCg256F   ( R = 0-7, G = 0-7, B = 0-3 )
uint8_t RGB256(uint8_t r,uint8_t g, uint8_t b);

//----  RGB2oCg64kF   ( R = 0-31, G = 0-63, B = 0-31 )
uint16_t RGB64k(uint8_t r,uint8_t g, uint8_t b);

//---  F[hw(AhXwtj
/*		dir: 0/A1/ */
void setMode(uint8_t md, uint8_t dir);

//---  \GA̐ݒ
/*		(x0,y0)-(x1,y1)FGAw */
void setArea(uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1);

//---  \GÃZbg
void rstArea();

/******* ANZ[VR}h **********/
/*		(x0,y0)-(x1,y1)FGAw */
//---  ʃNA
void gOLED_Clr(uint8_t x0,uint8_t y0,uint8_t x1,uint8_t y1);

//---  `i256Fj
void gOLED_Line(uint8_t x0,uint8_t y0, uint8_t x1,uint8_t y1, uint8_t r, uint8_t g ,uint8_t b);

//---  lp``i256Fj
void gOLED_Rect(uint8_t x0,uint8_t y0, uint8_t x1,uint8_t y1, uint8_t r, uint8_t g ,uint8_t b);

//---  摜Rs[
void gOLED_Copy(uint8_t x0,uint8_t y0, uint8_t x1,uint8_t y1, uint8_t dx, uint8_t dy);

//---  hԂOn[1]/Off[0]
void gOLED_Fill(uint8_t fl);

/******* Ep^[` ******/
//---  1hbg`(256Fj
/*		(x,y)ʒucolFŃhbg` */
void gOLED_Pset256(uint8_t x, uint8_t y,uint8_t col);

//----  5x7hbgASCIIP\(256Fj
/*		(x,y)ʒuASCII(dat)colFŕ`
 *	rtn: \xʒu								 */
uint8_t gOLED_chrX(uint8_t x, uint8_t y, char dat, uint8_t c);

//----  5x7hbgASCII\(256Fj 
/*		(x,y)ʒuASCII(*str)colFŕ`
 *	rtn: \xʒu								 */
uint8_t gOLED_strX(uint8_t x, uint8_t y, char *str, uint8_t c);

//----  ptHgAhX擾
/*		chCode: pR[hi0-0xFF)
 *	rtn: R[hi[AhX */
uint32_t HfntAdr(uint8_t chCode);

//----  Sp(jtHgAhX擾)
/*		kCode: SpR[hi0x2121-0x7426)
 *	rtn: R[hi[AhX */
uint32_t KfntAdr(uint16_t kCode);

//----  8x16hbgP\(256Fj
/*		(x,y):\JnʒuA *hpFtHgf[^AhXAcolF\F
 *	rtn: \xʒu								 */
 uint8_t gOLED_HptnX(uint8_t x, uint8_t y, char *hp, uint8_t col);

//---- p(8x16)\ixposʒuԂj
/*		(x,y)F\JnʒuAchCodeFR[hi0-255)AcolF\F
 *	rtn: \xʒu								 */
uint8_t gOLED_HchrX(uint8_t x, uint8_t y, uint8_t chCode,uint8_t col);

//---- p(8x16)\ixposʒuԂj-----
/*		(x,y)F\JnʒuAchCodeFp(*str)AcolF\F
 *	rtn: \xʒu								 */
uint8_t gOLED_HstrX(uint8_t x, uint8_t y, char *str,uint8_t col);

//----  SpiA16x16)P\(256Fj
/*		(x,y):\JnʒuA *kpFtHgf[^AhXAcolF\F
 *	rtn: \xʒu								 */
uint8_t gOLED_KptnX(uint8_t x, uint8_t y, char *kp, uint8_t col);

//---- Sp(A16x16j\
/*		(x,y)F\JnʒuAkCdFSpR[hAcolF\FA
 *		edFGfBA(0:gJISϊA1:rbOJISϊA2:gA3:rbOj
 *	rtn: \xʒu								 */
uint8_t gOLED_ZchrX(uint8_t x, uint8_t y, uint16_t kCd,uint8_t col, uint8_t ed);

//---- Sp(A16x16j\
/*		(x,y)F\JnʒuA*strFSpAcolF\FA
 *		edFGfBA(0:gJISϊA1:rbOJISϊA2:gA3:rbOj
 *	rtn: \xʒu								 */
uint8_t gOLED_ZstrX(uint8_t x, uint8_t y, char *str,uint8_t col, uint8_t ed);

//--- p^[f[^\(256Fj
/*		(x,y)F\JnʒuA*ptnFp^[f[^Axn/yn:/hbg
 *		vhF0/`A1/`		*/
void gOLED_ptnX(uint8_t x, uint8_t y, uint8_t *ptn, uint8_t xn, uint8_t yn, uint8_t vh);

//--- p^[f[^\(64kFA[hPj
/*		(x,y)F\JnʒuA*ptnFp^[f[^Axn/yn:/hbg
 *		vhF0/`A1/` */
void gOLED_ptnX_FC2(uint8_t x, uint8_t y, uint8_t *ptn, uint8_t xn, uint8_t yn, uint8_t vh);

//--- p^[f[^\(64kFA[hQj
/*		(x,y)F\JnʒuA*ptnFp^[f[^Axn/yn:/hbg
 *		vhF0/`A1/` */
void gOLED_ptnX_FC3(uint8_t x, uint8_t y, uint8_t *ptn, uint8_t xn, uint8_t yn, uint8_t vh);

/****** end of file *******/
